/* - Local libraries;
libname CRSPA "F:\New Data\CRSP\sasdata\q_stock";  				* used for smaller CRSP and Compustat for laptop (citoof year:2000);
libname CompA "F:\New Data\comp\nam";
libname IVBProj "D:\Fama Macbeth\SAS Works\IVBetaProjFF3";
* libname TAQProj "E:\Joonki Data Folder\SAS Works\TAQProj";
* libname EHDCRSP "D:\Fama Macbeth\RawData\CRSP";	
libname EHDCRSP "F:\New Data\CRSP\sasdata\q_stock";
libname EHDComp "D:\Fama Macbeth\RawData\Compustat";		*full CRSP and Compustat;
libname FF "F:\New Data\ff\sasdata";		* libname FRB "E:\RawData\FRB";		
%let serverID = 2;
*/

%let CRSPCutYr = 1952; 
%let DimsonT_Th = 1;

* - Local libraries;
* - Local libraries;
libname CRSPA "E:\New Data\CRSP\sasdata\q_stock";  				* used for smaller CRSP and Compustat for laptop (citoof year:2000);
libname CompA "E:\New Data\comp\nam";
libname IVBProj "D:\Fama Macbeth\SAS Works\IVBetaProjFF3";
* libname TAQProj "E:\Joonki Data Folder\SAS Works\TAQProj";
* libname EHDCRSP "D:\Fama Macbeth\RawData\CRSP";	
libname EHDCRSP "E:\New Data\CRSP\sasdata\q_stock";
libname EHDComp "D:\Fama Macbeth\RawData\Compustat";		*full CRSP and Compustat;
libname FF "E:\New Data\ff\sasdata";		* libname FRB "E:\RawData\FRB";		
%let serverID = 2;





* The following can be created as a single document;

%let RBLeng1=3;
%let RetdCntCut = 200;


* Loading monthly CRSP data;
data CRSP_Mon_Tab; set IVBProj.CRSP_CCM_Comp_Mon_Tab; 
	keep permno date ret rf Sizem Mom6 B2M B2M; run;

proc sort data=CRSP_Mon_Tab; by date permno; run;
data CRSP_Mon_Tab_Ch; set CRSP_Mon_Tab; by date; if first.date; run;

************************************************;
** - Combining IVBetas and Monthly CRSP data   *;
************************************************;

* FF3;
proc sql; 
	create table CRSPm_FinTab_RBd_FF3 (drop=Npermno Ndate) as select *
	from CRSP_Mon_Tab as a,
		 IVBProj.CRSPd_RBetas_cap (rename=(permno=Npermno date=Ndate)) as b
	where a.permno = b.Npermno and year(a.date) = year(b.Ndate) and
		  month(a.date) = month(b.Ndate); quit;
proc sort data=CRSPm_FinTab_RBd_FF3; by permno date; run;
data IVBProj.CRSPm_FinTab_RBd_cap_&RBLeng1._&RetdCntCut; set CRSPm_FinTab_RBd_FF3; run;


* Define FBOLS variables to match the coding the GetMacros_IVB_Rep_org.sas;

data CRSPm_FinTab_RBd_FF3;
set CRSPm_FinTab_RBd_FF3;
mktrf_FBOLS=mktrf_FM;
if year(date)<2013 and year(date)>1955;
run;



%Include "C:\Users\zghtc\Desktop\Kuntara RA\KuntaraGetMacros_IVB_Rep_org.sas";

***********************************************; 
***********************************************; * We are using the Excess returns!!;
* - Running Fama-MacBeth Regressions    	  *; * Based on rolling betas;
*   with CRSP Monthly + Time-varying IVBetas  *; * No need for One-month bias correction for FM;
***********************************************;
** - Defining the Macro Variables;
**   Risk Factors;
data Reg_varname_Mon_Ind; length Vname $50 Vname_suffix $10; input Vname $ Vname_suffix $;
	datalines;
	MKTRF _Coef

	MKTRF_FBOLS _Coef

; run; 
**   Characteristics (One-month Lagged); 
data Reg_varname_Mon_Ind_Chars; length Vname $100 Vname_suffix $20; input Vname $ Vname_suffix $;
	datalines;
	Sizem_1 _Coef
	B2M_1 _Coef
	Mom6 _Coef	
; run; 
* Mom6 is already delayed in its construction;


**************;
*** - FF3	 *;
**************;
** 1. IVFM;
%GetRegNameVec(dname=Reg_varname_Mon_Ind,Varrange=(1),type=1,NVarInd=Partial); 
%GetRegNameVec(dname=Reg_varname_Mon_Ind_Chars,Varrange=(1,2),type=2,NVarInd=Partial);
%let XSecCharVars = &CVnamelist; 
%DelayChars(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,Outdname=CRSPm_FinTab_RBd_FF3);
%RunIVXsecReg(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,depvname=Ret,rfvname=rf,
			  Regressors=&Vnamelist &CVnamelist,EndoVars=&Vnamelist,IVs=&IVnamelist,Outdname=XR_Ind_FF3_D_IV);
*%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D_IV,varlist=&Vnamelist &CVnamelist,coeflist=&Cnamelist &CCnamelist,reglist=&Rnamelist &CRnamelist,JWOpt=0); 	

* IVFM-Trunc (two methods);
%RunXsecReg(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,depvname=Ret,rfvname=rf,Regressors=MKTRF_FBOLS &CVnamelist,Outdname=XR_Ind_FF3_D);
%GetIVFMTrunc_CAP(IVdname=XR_Ind_FF3_D_IV,OLSdname=XR_Ind_FF3_D,BndMulti=4,Outdname=XR_Ind_FF3_D_IVT);
*%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D_IVTNF,varlist=&Vnamelist &CVnamelist,coeflist=&Cnamelist &CCnamelist,reglist=&Rnamelist &CRnamelist,JWOpt=0); 	
%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D_IVTF,varlist=&Vnamelist &CVnamelist,coeflist=&Cnamelist &CCnamelist,reglist=&Rnamelist &CRnamelist,JWOpt=0); 
	
* %GetHansenHodrickCorrection_MEst(dname=XR_Ind_FF3_D_IVTF,varlist=&Vnamelist &CVnamelist, NLag=36);

%RunIVXsecReg(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,depvname=Ret,rfvname=rf,
			  Regressors=&Vnamelist,EndoVars=&Vnamelist,IVs=&IVnamelist,Outdname=XR_Ind_FF3_D_IV);

* IVFM-Trunc (two methods);
%RunXsecReg(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,depvname=Ret,rfvname=rf,Regressors=MKTRF_FBOLS &CVnamelist,Outdname=XR_Ind_FF3_D);
%GetIVFMTrunc_CAP(IVdname=XR_Ind_FF3_D_IV,OLSdname=XR_Ind_FF3_D,BndMulti=4,Outdname=XR_Ind_FF3_D_IVT);
*%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D_IVTNF,varlist=&Vnamelist,coeflist=&Cnamelist,reglist=&Rnamelist,JWOpt=0); 	
%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D_IVTF,varlist=&Vnamelist,coeflist=&Cnamelist,reglist=&Rnamelist,JWOpt=0); 	
* %GetHansenHodrickCorrection_MEst(dname=XR_Ind_FF3_D_IVTF,varlist=&Vnamelist, NLag=36);




** 2. Standard FM;
%GetRegNameVec(dname=Reg_varname_Mon_Ind,Varrange=(2),type=1,NVarInd=Partial); 
%GetRegNameVec(dname=Reg_varname_Mon_Ind_Chars,Varrange=(1,2),type=2,NVarInd=Partial);
%let XSecCharVars = &CVnamelist;  
* %DelayChars(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,Outdname=CRSPm_FinTab_RBd_FF3); *Do not need to delay it twice;
%RunXsecReg(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,depvname=Ret,rfvname=rf,Regressors=&Vnamelist &CVnamelist,Outdname=XR_Ind_FF3_D);
%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D,varlist=&Vnamelist &CVnamelist,coeflist=&Cnamelist &CCnamelist,reglist=&Rnamelist &CRnamelist,JWOpt=0);


** 2. Standard FM;
%GetRegNameVec(dname=Reg_varname_Mon_Ind,Varrange=(2),type=1,NVarInd=Partial); 
%GetRegNameVec(dname=Reg_varname_Mon_Ind_Chars,Varrange=(1,2),type=2,NVarInd=Partial);
%let XSecCharVars = &CVnamelist;  
* %DelayChars(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,Outdname=CRSPm_FinTab_RBd_FF3); *Do not need to delay it twice;
%RunXsecReg(dname=CRSPm_FinTab_RBd_FF3,byvname=permno,depvname=Ret,rfvname=rf,Regressors=&Vnamelist,Outdname=XR_Ind_FF3_D);
%GetNeweyWestCorrection_No(dname=XR_Ind_FF3_D,varlist=&Vnamelist,coeflist=&Cnamelist ,reglist=&Rnamelist ,JWOpt=0);


